/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


# ifndef DVDREADER_H
# define DVDREADER_H

using namespace std;

// Fuer DVD_read damit die Uint_Max Macros eingebunden werden
# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif
# include <stdint.h>

# include <dvdread/ifo_read.h>
# include <dvdread/ifo_print.h>

# include <qobject.h>
# include <qstring.h>
# include <qcombobox.h>
# include <iostream>

# include "Decodieren.h"

using namespace std;

class DVDReader : public QObject
{
    Q_OBJECT

    private:
        QString temp,                            // Fuer Temporaere String operationen
                zeit,                            // Die Zeit der Titel
                audio,                           // Die Audio Zeile
                untertitel,                      // Die Untertitle Zeile
                programmsprache,                 // Die Programmsprache wird hier abgespeichert
                asid[8],                         // Der Wert der fuer den Audiostream gebraucht wird
                ssid[32];                        // Der Wert der fuer den Untertitelstream gebracht wir

        dvd_reader_t *dvdZeiger;                 // Der Zeiger des DVD_Objekts
        ifo_handle_t *ifoZeiger;                 // Der Zeiger der die DVD Informationen herausflitern soll
        ifo_handle_t *ifoZeigerNull;             // die ist der Zeiger auf das Null Objekt der DVD (Main-Infos)
        dvd_time_t   *zeitZeiger;                // Der Zeiger mit dem die Speil Zeit abgeholt wird
        audio_attr_t *audioZeiger;               // Der zeige mit dem die Audio Daten herausgefiltert werden
        subp_attr_t  *unterZeiger;               // Der Zeiger mit dem die Untertitel Informationen geholt werden

        int titeln,                              // Wie Viele Titeln es auf der DVD gibt
            pgcit_Zaehler;                       // zum zaehlern der Durchlaufen

        uint tempsid;                            // Temporaere Variable zum rechnen

        QComboBox *cotitel,                      // Der uebergebene Zeiger der ComboBox  die die Auswahl der Titel anzeigt 
                  *coalang,                      // Der uebergebene Zeiger der ComboBox  die die Auswahl der Audiospur anzeigt
                  *countertitel;                 // Der uebergebene Zeiger der ComboBox  die die Auswahl der Untertitel anzeigt

       Decodieren *decodieren;                   // Der uebergebene Zeiger von Decodieren

       // Die Titlelaengen lesen
       void leseTitel(void);

       // Alle anzeigen leeren
       void leeren (void);

        // Titel laenge einlesen
        QString leseFormat (void);

        // Titel Sprache einlesen
        QString leseSprache (void);

        // Untertitel Zeile einlesen
        QString leseUSprache (void);

        // Sprach-Kuerzel in Text umsetzen
        QString umsetzen (QString &kuerzel);

    signals:
        // Sendet die Laenge des dazugehoerigen Titels
        void laenge(QString);

    public:
        DVDReader(QComboBox *titel,QComboBox *alang,QComboBox *untertitel,Decodieren *deco);

    public slots:

        // Die DVD-Daten holen und weitergeben
        void leseDVD (QString pfad);

        // DVD-Zeiger loesen
        void loeseDVD (void);

        // Audio Zeile einlesen
        void leseAudio (int titel);

        // Untertitel Zeile einlesen
        void leseUntertitel (int titel);

        // Die Sprache auf Deutsch setzen
        void setDeutsch(void);

        // Die Sprache auf English setzen
        void setEnglish(void);

        // Damit der richtige asid-Wert geholt wird
        void holeasid (int titel);

        // Damit der richtige asid-Wert geholt wird
        void holessid (int titel);
};

# endif
