/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef DECODIEREN_CPP
# define DECODIEREN_CPP

# include "Decodieren.h"

Decodieren::Decodieren (QWidget *parent,QString versionsnummer)
{
    if(debuglevel>=2)
    {
        cout<<" * Konstructor : Decodieren *"<<endl<<endl;
    }

    // Speichert das Eltern Widget ab
    eltern=parent;

    // Uebergeben Version ablegen
    version=versionsnummer;

    // Erzeugt das ein Timerobjekt fuer das herunterfahren
    timer=new QTimer(eltern);
    connect(timer,    SIGNAL(timeout()),this,SLOT(herunterfahren()));

    // Erzeugt das ein Timerobjekt fuer die Konrolle des Aufrufthreads
    wartezeit=new QTimer(eltern);
    connect(wartezeit, SIGNAL(timeout()),this,SLOT(checkaufruf()));

    //Die Datenobjekte einmal erstellen
    for(int var=0;var<10;var++)
    {
        daten[var] = new Daten();
    }

    // Damit im var_reset() der vorherigeZuweisen() nicht schief geht
    durchlauf=0;

    // Die Zeitfelder Varibalen auf Anfangswert setzen
    korrektur="0";
    boolstartzeit=false;
    boolendzeit=false;

    // Damit als erster der erste String beschrieben wird
    var_reset();

    // Laet die Gespeicherten Einstellungen
    laden();

    // Encodieraufruf Objekt erstellen
    encodieraufruf = new Aufruf();
}

QString Decodieren::bauen (int welcherDurchlauf,bool pass)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : bauen *"<<endl<<endl;
    }

    if(pass==false)
    {
        // Die Endzeit Errechnen
        boolendzeit=neostring.zeitrechnen(daten[welcherDurchlauf]->startzeit,
            daten[welcherDurchlauf]->endzeit,korrektur);

         // Kontrolle ob sich die Zeit ueberhaupt geandert hat
        if(!(daten[welcherDurchlauf]->startzeit=="00:00:00"))
        {
        // Damit diese Option dann auch hinzugefuegt wird
            boolstartzeit=true;
        }
        else
        {
        // Damit diese Option nicht hinzugefuegt wird
            boolstartzeit=false;
        }
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    daten[welcherDurchlauf]->zerlegtOutfilename = daten[welcherDurchlauf]->outfilename;

    // String kontrolliern ob er Leerzeichen enthaelt und diese fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[welcherDurchlauf]->zerlegtOutfilename);

    // Stellt den Ausgabestring zusammen
    tempausgabe="mencoder dvd://"+daten[welcherDurchlauf]->titelnummer;
    tempausgabe+=" -dvd-device "+daten[welcherDurchlauf]->zerlegtIndirname;

    // Kontrolle ob der Anfang weggeschnitten werden muss
    if(boolstartzeit==true)
    {
        tempausgabe+=" -ss "+daten[welcherDurchlauf]->startzeit;
    }

     // Kontrolle ob das Ende weggeschnitten werden muss
     if(boolendzeit==true)
     {
        tempausgabe+=" -endpos "+daten[welcherDurchlauf]->endzeit;
     }

     // Untertiteln hinzufuehgen wenn etwas ausgewaehlt worden ist
     if(!(daten[welcherDurchlauf]->asid==""))
     {
         tempausgabe+=" -aid "+daten[welcherDurchlauf]->asid;
     }

     // Untertiteln hinzufuehgen wenn etwas ausgewaehlt worden ist
     if(!(daten[welcherDurchlauf]->ssid==""))
     {
         tempausgabe+=" -sid "+daten[welcherDurchlauf]->ssid;
     }

    tempausgabe+=" -oac "+daten[welcherDurchlauf]->audioopt;
    tempausgabe+=" -ovc xvid -xvidencopts bitrate="+daten[welcherDurchlauf]->bitrateopt;

    // Kontrolle ob "boolcartoon" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->boolcartoon==true)
    {
        tempausgabe+=":cartoon";
    }

    // Kontrolle ob "boolautoapect" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->boolautoaspect==true)
    {
        tempausgabe+=":autoaspect";
    }

    // Den Wert fuer dei Bewegungsabschaetzung hinzufuegen wenn noetig
    if(!(daten[welcherDurchlauf]->vhqWert=="0"))
    {
        tempausgabe+=":vhq="+daten[welcherDurchlauf]->vhqWert;
    }

    // Kontrolle ob "bool2pass" wahr ist um die entsperchende Option einzufuegen
    if(daten[welcherDurchlauf]->bool2pass==true)
    {
        // Kontrolle ob es der erste Durchlauf oder der zweite ist
        if(pass==false)
        {
            tempausgabe+=":pass=1";
        }
        else
        {
            tempausgabe+=":pass=2";
        }
    }

    // Schliesst den Ausgabestream ab
    tempausgabe+=" -o "+daten[welcherDurchlauf]->zerlegtOutfilename;

    // Wenn die Datein nachher zusammengefuegt werden sollen dann fuege .part hinten hinzu
    if(boolzusammenfuegen==true)
    {
        tempausgabe+=".part";
    }

    // Damit die Temporaere "pass Datei von Xvid nicht im Home Ordner herumliegt
    tempausgabe+=" -passlogfile /tmp/2PassStatus.log";

    // Diese Optionen nur beim ersten Durchgang anwenden
    if(pass==false)
    {
        // Damit wenn zusammegfuegt werden soll alle Namen bekannt sind
        ausgabenamen[welcherDurchlauf]=daten[welcherDurchlauf]->zerlegtOutfilename;
    }

    return tempausgabe;
}

void Decodieren::setindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setindirname *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *inname = new QFileDialog(eltern);

    // Falls die Auswahl abgerochen wird merke dir denn alten Wert 
    temp=daten[durchlauf]->indirname;

    // Oeffnet einen Dialog in dem man nur Ordner auswaehlen kann
    daten[durchlauf]->indirname=inname->getExistingDirectory(daten[durchlauf]->indirname,eltern);

    if(debuglevel==3)
    {
        cout<<" Eingabegabename = "<<daten[durchlauf]->indirname<<endl<<endl;
    }

    // Kontrolle ob der Rueckgabe wert vom Filedialog nicht NULL ist
    if(daten[durchlauf]->indirname==NULL)
    {
        daten[durchlauf]->indirname=temp;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Filedialogs noetig)
    daten[durchlauf]->zerlegtIndirname  = daten[durchlauf]->indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[durchlauf]->zerlegtIndirname);

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    //emit ordnerausgewaehlt(daten[durchlauf]->zerlegtIndirname);
    emit ordnerausgewaehlt(daten[durchlauf]->indirname);
}

void Decodieren::set_indirname(QString name)
{
    //Weist nur den indrinamen zu
    daten[durchlauf]->zerlegtIndirname=name;

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    emit ordnerausgewaehlt(daten[durchlauf]->zerlegtIndirname);
}

void Decodieren::setoutname (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setoutname *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *outname = new QFileDialog(eltern);

     // Oeffnet einen Dialog in dem man den Ort und den Dateinamen auswaehlen kann
    tempoutfilename=outname->getSaveFileName(daten[durchlauf]->outfilename,0,eltern);

    // Zur Kontrolle ob der zurueckgegeben Pfad auch etwas enthaelt
    if (!(tempoutfilename==0))
    {
        daten[durchlauf]->outfilename=tempoutfilename;
    }

    if(debuglevel==3)
    {
        cout<<" Ausgabename = "<<daten[durchlauf]->outfilename<<endl<<endl;
    }
}

void Decodieren::setcartoon (bool cartoon)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setcartoon *"<<endl<<endl;
    }

    // Weist der "boolcartoon" Variable den uebergeben Wert zu
    daten[durchlauf]->boolcartoon=cartoon;

    if(debuglevel==3)
    {
        cout<<" Cartoon Obtimierungs Wert = "<<daten[durchlauf]->boolcartoon<<endl<<endl;
    }
}

void Decodieren::set2pass (bool pass2)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : set2pass *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    daten[durchlauf]->bool2pass=pass2;

    if(debuglevel==3)
    {
        cout<<" 2-Pass Decodierungs Wert = "<<daten[durchlauf]->bool2pass<<endl<<endl;
    }
}

void Decodieren::setautoaspect(bool autoaspect)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setautoaspect*"<<endl<<endl;
    }

    // Weist der "boolautoaspects" Variable den uebergeben Wert zu
    daten[durchlauf]->boolautoaspect=autoaspect;

    if(debuglevel==3)
    {
        cout<<" Autoaspect Options  Wert = "<<daten[durchlauf]->boolautoaspect<<endl<<endl;
    }
}

void Decodieren::setvhq(const QString& vhq)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setvhq*"<<endl<<endl;
    }

    // Weist der "vhqWert" Variable den uebergeben Wert zu
    daten[durchlauf]->vhqWert=vhq;

    if(debuglevel==3)
    {
        cout<<" VHQ  Wert = "<<daten[durchlauf]->vhqWert<<endl<<endl;
    }
}

void Decodieren::setshutdown (bool shutdown)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setshutdown *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    boolshutdown=shutdown;

    if(debuglevel==3)
    {
        cout<<" Schutdown Wert = "<<boolshutdown<<endl<<endl;
    }
}

void Decodieren::setauidoopt (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setaudioopt *"<<endl<<endl;
    }

    // Weist der "audiopt" Variable den uebergeben Audiooptionswert zu
    daten[durchlauf]->audioopt=audio;

    if(debuglevel==3)
    {
        cout<<" Audio Optionen ausgewaehlt = "<<daten[durchlauf]->audioopt<<endl<<endl;
    }
}

void Decodieren::setbitrateopt (const QString& bitrate)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setbitrateopt *"<<endl<<endl;
    }

    // Weist der "bitrateopt" Variable den uebergeben Bitratewert zu
    daten[durchlauf]->bitrateopt=bitrate;

    if(debuglevel==3)
    {
        cout<<" Bitrate Wert ausgewaehlt = "<<daten[durchlauf]->bitrateopt<<endl<<endl;
    }
}

void Decodieren::settitel (int titel)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : settitel *"<<endl<<endl;
    }

    // Weist der "titelnummert" Variable den uebergeben Wert zu
    daten[durchlauf]->titelnummer.setNum(titel+1);

    emit  titelausgewaehlt(titel+1);

    if(debuglevel==3)
    {
        cout<<" Titelnummer ausgewaehlt = "<<daten[durchlauf]->titelnummer<<endl<<endl;
    }
}

void Decodieren::setmountpfad (QString mount)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setmountpfad *"<<endl<<endl;
    }

    // Weist der "mountpfad" Variable den uebergeben Wert zu
    mountpfad=mount;

    if(debuglevel==3)
    {
        cout<<" Mountpfad geaendert = "<<mountpfad<<endl<<endl;
    }
}

void Decodieren::setaudio (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setaudio *"<<endl<<endl;
    }

    // Weist der "alang" Variable den uebergeben Wert zu
    daten[durchlauf]->alang=audio.left(2);

    if(debuglevel==3)
    {
        cout<<" Audiospur ausgewaehlt = "<<daten[durchlauf]->alang<<endl<<endl;
    }
}

void Decodieren::setuntertitel (const QString& untertitel)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setuntertitel *"<<endl<<endl;
    }

    // Weist der "untertitelnummer" Variable den uebergeben Wert zu
    daten[durchlauf]->untertitelnummer=untertitel.left(2);

    if(debuglevel==3)
    {
        cout<<" Untertitel ausgewaehlt = "<<daten[durchlauf]->untertitelnummer<<endl<<endl;
        cout<<" Temporaere umwandlungszahl = "<<umwandeln<<endl<<endl;
    }
}

void Decodieren::setdebug (int auswahl)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setdebug *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable zugewiesne und setzt den Debuglevel
    debuglevel=auswahl;

    // denn Debuglevel auch nach Einstellen speicheren
    einstellungen.debuglevel = auswahl;

    if(debuglevel==3)
    {
        cout<<" debuglevel variable = "<<debuglevel<<endl<<endl;
    }

}

void Decodieren::setbooleject (bool eject)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setbooleject *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    booleject=eject;

    if(debuglevel==3)
    {
        cout<<" boolecejt variable = "<<booleject<<endl<<endl;
    }
}

void Decodieren::setboolunmount (bool unmount)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setunmount *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    boolunmount=unmount;

    if(debuglevel==3)
    {
        cout<<" boolunmount variable = "<<boolunmount<<endl<<endl;
    }
}

void Decodieren::setzusammenfuegen (bool zusammenfuegen)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setzusammenfuegen *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolzusammenfuegen"zugewiesen
    boolzusammenfuegen=zusammenfuegen;

    // Die Darstellung im Stapelfenster richtig stellen
    emit part(boolzusammenfuegen);

    if(debuglevel==3)
    {
        cout<<" boolzusammnefuegn variable = "<<boolzusammenfuegen<<endl<<endl;
    }
}

void Decodieren::setpart (bool part)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setpart *"<<endl<<endl;
    }

    // Wenn "true" dann sollen die ".part" Datein nachher geloescht werden
    boolpart=part;

    if(debuglevel==3)
    {
        cout<<" boolpart variable = "<<boolpart<<endl<<endl;
    }
}

void Decodieren::setsprache (QString neuesprache)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setsprache *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "sprache"zugewiesen
    sprache=neuesprache;

    if(debuglevel==3)
    {
        cout<<" Sprachen variable = "<<boolpart<<endl<<endl;
    }
}

void Decodieren::setasid (QString asid)
{
    // Den asid (Audio Stream ID) Wert speicheren
    daten[durchlauf]->asid=asid;
}

void Decodieren::setssid (QString ssid)
{
    // Den ssid (subtitle Stream ID) Wert speicheren
    daten[durchlauf]->ssid=ssid;
}

void Decodieren::setausgeben (bool ausgeben)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setausgeben *"<<endl<<endl;
    }

    // Waehrend des Encodierens Meldungen an der Standardausgabe ausgeben
    boolausgeben=ausgeben;
}

void Decodieren::setkorrektur (const QString& korrekt)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setkorrektur *"<<endl<<endl;
    }

    korrektur=korrekt;

    if(debuglevel==3)
    {
        cout<<" korrekur variable = "<<korrektur<<endl<<endl;
    }
}
QString Decodieren::getindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getindirname *"<<endl<<endl;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    daten[durchlauf]->zerlegtIndirname   = daten[durchlauf]->indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(daten[durchlauf]->zerlegtIndirname);

    return daten[durchlauf]->indirname;
}

QString Decodieren::getmountpfad (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getmountpfad *"<<endl<<endl;
    }

    return mountpfad;
}

bool Decodieren::getcartoon(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getcartoon *"<<endl<<endl;
    }

    return daten[durchlauf]->boolcartoon;
}


bool Decodieren::get2pass(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : get2pass *"<<endl<<endl;
    }

    return daten[durchlauf]->bool2pass;
}

bool Decodieren::getautoaspect(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getautoaspect *"<<endl<<endl;
    }

    return daten[durchlauf]->boolautoaspect;
}

QString Decodieren::getvhq(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getvhq *"<<endl<<endl;
    }

    return daten[durchlauf]->vhqWert;
}

bool Decodieren::getshutdown(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getshutdown *"<<endl<<endl;
    }

    return boolshutdown;
}

QString Decodieren::getaudioopt(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getaudioopt *"<<endl<<endl;
    }

    return daten[durchlauf]->audioopt;
}

QString Decodieren::getbitrateopt(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getbitrate *"<<endl<<endl;
    }

    return daten[durchlauf]->bitrateopt;
}

bool Decodieren::getunmount(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getunmount *"<<endl<<endl;
    }

    return boolunmount;
}

bool Decodieren::geteject(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : geteject *"<<endl<<endl;
    }

    return booleject;
}

bool Decodieren::getzusammenfuegen(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getzusammenfuegn *"<<endl<<endl;
    }

    return boolzusammenfuegen;
}

bool Decodieren::getpart(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getpart *"<<endl<<endl;
    }

    return boolpart;
}

int Decodieren::getdebug (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getdebug *"<<endl<<endl;
    }

    return debuglevel;
}

bool Decodieren::getausgeben(void)
{
    return boolausgeben;
}
QString Decodieren::getsprache (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getsprache *"<<endl<<endl;
    }

    return sprache;
}

void Decodieren::ruecksetzen(void)
{
    // Alle Einstellungen auf die Standardwerte setzen und den Variablen zuweisen
    einstellungen.ruecksetzen();
    zuweisen();

    //Damit nach dem ruecksetzen alle die Anzeigen stimmen
    set_indirname(einstellungen.indirname);
}

void Decodieren::laden(void)
{
    // Die gespeicherten Einstellungen laden und den Variablen zuweisen
    einstellungen.laden((neostring.homepfad()+".dvd2xvid/"),version);
    zuweisen();
}

void Decodieren::zuweisen(void)
{
    // Weist die Werte aus Einstellungen den Varibalen zu
    daten[durchlauf]->indirname          = einstellungen.indirname;
    daten[durchlauf]->outfilename        = einstellungen.outfilename;
    daten[durchlauf]->boolcartoon        = einstellungen.boolcartoon;
    daten[durchlauf]->bool2pass          = einstellungen.bool2pass;
    daten[durchlauf]->boolautoaspect     = einstellungen.boolautoaspect;
    daten[durchlauf]->audioopt           = einstellungen.audioopt;
    daten[durchlauf]->bitrateopt         = einstellungen.bitrateopt;
    daten[durchlauf]->vhqWert            = einstellungen.vhqWert;
    mountpfad                            = einstellungen.mountpfad;
    debuglevel                           = einstellungen.debuglevel;
    boolshutdown                         = einstellungen.boolshutdown;
    boolunmount                          = einstellungen.boolunmount;
    booleject                            = einstellungen.booleject;
    boolzusammenfuegen                   = einstellungen.boolzusammenfuegen;
    boolpart                             = einstellungen.boolpart;
    boolausgeben                         = einstellungen.boolausgeben;
    sprache                              = einstellungen.sprache;
}

void Decodieren::speichern(void)
{
    // Weist die Werte aus Decodiern den Varibalen zu
    einstellungen.indirname          = daten[durchlauf]->indirname;
    einstellungen.outfilename        = daten[durchlauf]->outfilename;
    einstellungen.boolcartoon        = daten[durchlauf]->boolcartoon;
    einstellungen.bool2pass          = daten[durchlauf]->bool2pass;
    einstellungen.boolautoaspect     = daten[durchlauf]->boolautoaspect;
    einstellungen.audioopt           = daten[durchlauf]->audioopt;
    einstellungen.bitrateopt         = daten[durchlauf]->bitrateopt;
    einstellungen.vhqWert            = daten[durchlauf]->vhqWert;
    einstellungen.mountpfad          = mountpfad;
    einstellungen.debuglevel         = debuglevel;
    einstellungen.boolshutdown       = boolshutdown;
    einstellungen.boolunmount        = boolunmount;
    einstellungen.booleject          = booleject;
    einstellungen.boolzusammenfuegen = boolzusammenfuegen;
    einstellungen.boolpart           = boolpart;
    einstellungen.boolausgeben       = boolausgeben;
    einstellungen.sprache            = sprache;

    // Speichert die Einstellungen in die Confdatei
    einstellungen.speichern();
}

void Decodieren::vorherigeZuweisen (int var)
{
    if(0<durchlauf)
    {
        daten[var]->indirname          = daten[durchlauf-1]->indirname;
        daten[var]->zerlegtIndirname   = daten[durchlauf-1]->zerlegtIndirname;
        daten[var]->outfilename        = daten[durchlauf-1]->outfilename;
        daten[var]->boolcartoon        = daten[durchlauf-1]->boolcartoon;
        daten[var]->bool2pass          = daten[durchlauf-1]->bool2pass;
        daten[var]->boolautoaspect     = daten[durchlauf-1]->boolautoaspect;
        daten[var]->audioopt           = daten[durchlauf-1]->audioopt;
        daten[var]->bitrateopt         = daten[durchlauf-1]->bitrateopt;
        daten[var]->untertitelnummer   = daten[durchlauf-1]->untertitelnummer;
        daten[var]->alang              = daten[durchlauf-1]->alang;
        daten[var]->titelnummer        = daten[durchlauf-1]->titelnummer;
        daten[var]->vhqWert            = daten[durchlauf-1]->vhqWert;
    }
}

void Decodieren::vorschau(void)
{
    vorschaustring="gmplayer dvd://"+daten[durchlauf]->titelnummer+" -dvd-device "+daten[durchlauf]->zerlegtIndirname;

    // Die Vorschau mit den richtigen Ton abspielen
    if(!(daten[durchlauf]->asid==""))
    {
        vorschaustring+=" -aid "+daten[durchlauf]->asid;
    }

    // Die Vorschau mit den richtigen Untertitlen abspielen
    if(!(daten[durchlauf]->ssid==""))
    {
        vorschaustring+=" -sid "+daten[durchlauf]->ssid;
    }

    // Damit man dem Aufruf auch sieht
    cout<<endl<<vorschaustring<<endl<<endl;

    // Vorschau ausfueren und den Rueckgabewert kontrollieren
    if(!(system(vorschaustring)==256))
    {
        // Wenn der Rueckgabe wert nicht "256" ist starte nochmal mit den "mplayer" Kommando
        vorschaustring.remove(1,0);
        system(vorschaustring);
    }
}

void Decodieren::starten(void)
{
    // Hauptfenster unsichtbar machen
    emit verstecken();

    // Startet dann den Eigentlichen Encodiervorgang
    checkaufruf();
}

void Decodieren::herunterfahren(void)
{
    // die Timer schleife auch wieder stoppen
    timer->stop();

    if(boolshutdown==true)
    {
        // Mit diesem Befehl wird der Computer herunter gefahren
        system("poweroff &");

        // Programm beenden
        emit runterfahren();
    }
    else
    {
        // Damit wird der Wert wieder richtig gestellt wie er in der GUI angezeigt wird
        boolshutdown=true;
    }
}

void Decodieren::anhaengen (void)
{
    if(durchlauf<=8)
    {
        // den momentane Durchlauf auf aktiv setzen
        daten[durchlauf]->aktivieren(true);

        // Kontrolle ob der letzte Dateinamen auch so geheissen hat
        if(durchlauf>0)
        {
            if(daten[durchlauf]->outfilename==daten[durchlauf-1]->outfilename)
            {
                // das z kuerzel bei den Fieldialog hinzufuegen
                //daten[durchlauf]->outfilename=ausgabenamen[durchlauf-1]+".z";

                // das z bei den Ordnernamen hinzufuegen damit die naechste kontrolle der Dateinamen nicht fehl schlaegt
                daten[durchlauf]->outfilename+=".z";
            }
        }

        // Fuer die Anzeige im dem Stapelfenster
        emit aufruf(daten[durchlauf]->outfilename,daten[durchlauf]->titelnummer,daten[durchlauf]->boolcartoon,
                    daten[durchlauf]->bool2pass,daten[durchlauf]->boolautoaspect);

        durchlauf++;

        // Damit alle Zeiten zuruckgesetz werden
        emit zeitfelderrucksetzen();

        // Damit der neue Datensatz mit den alten werten arbeiten kann
        vorherigeZuweisen(durchlauf);
    }
    else
    {
        // Kontrolle Welche Sprache eingestellt ist
        if(sprache=="de")
        {
            ueberschrift="Stapelverarbeitung";
            haupttext   ="Maximale Auftragszahl erreicht.";
        }

        if(sprache=="en")
        {
            ueberschrift="Batch processing";
            haupttext   ="Maximum jobs reached.";
        }
        // Meldung ausgeben nicht mehr als zehn Auftraege gespeichert werden koennen 
        QMessageBox::critical(eltern,ueberschrift,haupttext,
                              QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
    }
}

void Decodieren::setstartzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setstartzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    daten[durchlauf]->startzeit=zeit;

    if(debuglevel>=3)
    {
        cout<<" startzeit = "<<daten[durchlauf]->startzeit<<endl<<endl;
    }
}

void Decodieren::setendzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setendzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    daten[durchlauf]->endzeit=zeit;

    if(debuglevel>=3)
    {
        cout<<" endzeit = "<<daten[durchlauf]->endzeit<<endl<<endl;
    }
}

void Decodieren::zusammenfuegen (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : zusammenfuegen *"<<endl<<endl;
    }

    // Kontrolle ob Zusammen fuegen uberhaupt noetig ist
    if(durchlauf>0)
    {
        // Aufruf fuer das zusammenfuegn zusammenabuen
        tempausgabe=" avimerge -i";

        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe+=" "+ausgabenamen[zaehler]+".part";
        }

        tempausgabe+=" -o "+ausgabenamen[0];

        // Ausgabe and die Standardausgabe
        cout<<endl<<" "<<tempausgabe<<endl<<endl;

        // Nur Simuliertes schreiben keine wirkliche Decodierung wenn Debuglevel nicht 0 ist
        if(debuglevel<1)
        {
            // Zusammenfuegen durch fuehren lassen
            system(tempausgabe);
            cout<<endl;
        }

        // Alle temporaeren part dateien loeschen wenn dies ausgewaehlt worden ist
        delpart();
    }
}

void Decodieren::delpart (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : delpart *"<<endl<<endl;
    }

    //Kontrolle ob die Datein wirklilch geloescht werden sollen
    if(boolpart==true)
    {
        // Aufruf fuer das loeschen der .part Datein zusammenabuen
        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe="rm "+ausgabenamen[zaehler]+".part";

            // Ausgabe and die Standardausgabe
            cout<<" "<<tempausgabe<<endl<<endl;

            if(debuglevel<1)
            {
                // Entsprechende Datei loeschen
                system(tempausgabe);
            }
        }
    }
}

void Decodieren::encodieren(void)
{
    // zuerset den Auftrag erstellen und das Fenster sichtbar machen
    anhaengen();

    // Begint mit den Encodieren
    starten();
}

void Decodieren::var_reset(void)
{
    // Damit der erste Datensatz mit den alten werten arbeiten kann
    vorherigeZuweisen(0);

    // Stringvar und durchlauf zuruecksetzen
    durchlauf       =0;
    zaehler         =0;
    bool2pass       = false;
    boolanhalten    = false;
    boolvoranhalten = false;
    boolletzter     = false;

    // Auch die Datenobjekte loeschen
    for(int var=0;var<10;var++)
    {
        daten[var]->aktivRuecksetzen();
    }
}

void Decodieren::checkaufruf (void)
{
    // kontrolliert ob der Decodierauftrag beentet ist
    if(encodieraufruf->running()==false)
    {
        wartezeit->stop();
        if(debuglevel>=2)
        {
            cout<<" Threadaufruf ist fertig! *"<<endl<<endl;
        }

        if((zaehler<durchlauf)&(boolanhalten==false))
        {
            // Kontrolle ob in diesen Datensatz ueberhaupt etwas drinnen steht
            if(daten[zaehler]->aktiv()==true)
            {
                // Schauen ob das der Letzte Durchlauf ist (noch nicht mit 2-Pass)
                if(zaehler==durchlauf-1)
                {
                    boolletzter=true;
                }

                if(bool2pass==false)
                {
                    // Den Ausgabestring zusammenbauen lassen
                    ausgabe=bauen(zaehler,false);

                    // Damit im Stapelfenster der Aktuelle Auftrag angezeit wird
                    emit aktiveZeile(zaehler,bool2pass,boolletzter);

                    // Wenn im 2Pass-Modus encodiert werden soll dann setze bool2pass auf "true"
                    if(daten[zaehler]->bool2pass==true)
                    {
                        bool2pass=true;
                    }
                    else
                    {
                        // Wenn kein 2-Pass erfolgt dann zaehle
                        zaehler++;
                    }
                }
                else
                {
                    // Kontrollieren ob er beim Naechsten durchlauf gestoppt werden soll
                    if(boolvoranhalten==true)
                    {
                        boolanhalten=true;
                    }

                    // Den Ausgabestring zusammenbauen lassen
                    ausgabe=bauen(zaehler,true);

                    // Damit im Stapelfenster der Aktuelle Auftrag angezeit wird
                    emit aktiveZeile(zaehler,bool2pass,boolletzter);

                    // boll2pass wieder auf "false" setzen damit der naechste Durchlauf beim 1pass begint
                    bool2pass=false;

                    zaehler++;
                }


                // Nur Simuliertes schreiben keine wirkliche Decodierung
                cout<<endl<<" "<<ausgabe<<endl<<endl;

                if(debuglevel<1)
                {
                    // Den Encodieraufruf an das Threadobjekt senden
                    encodieraufruf->setAufruf(ausgabe,boolausgeben);

                    // Den Thread starten mit den entsprechenden Aufruf
                    encodieraufruf->start();
                }
            }
            else
            {
                zaehler++;
            }

            // Mit Wartezeit start wird immer kontrolliert ob er schon fertig ist
            wartezeit->start(1500);
        }
        else
        {

           // Wenn die Decodierten Datein zusammengefuegt werden sollen dann fuere zusammenfuegen aus
           if(boolzusammenfuegen==true)
           {
               zusammenfuegen();
           }



           // kontrolliere ob die dvd nachher entbunden werden soll
           if(boolunmount==true)
           {
               emit umount();

               // kontrolliere ob die dvd lade geoeffnetz werden soll
               if(booleject==true)
               {
                   system(("eject "+mountpfad));
                   cout<<endl<<"eject "<<mountpfad<<endl;
               }
           }

           if(debuglevel<1)
           {
                // Wenn boolshutdown aktiviert ist dan fahre das System herunter
                if((boolshutdown==true)&(boolanhalten==false))
                {
                    // Die 15 Sekunden Verzoegerung starten
                    timer->start(15000);

                    // Kontrolle Welche Sprache eingestellt ist
                    if(sprache=="de")
                    {
                        ueberschrift="Wirklich Heruntergefahren?";
                        haupttext   ="Der Computer wird 15 Sekunden heruntergefahren oder abbrechen";
                    }

                    if(sprache=="en")
                    {
                        ueberschrift="Really shutdown?";
                        haupttext   ="The computer will shutdown in 15 seconds or abort";
                    }

                    // DIe zwischen Varibale zuruecksetzen
                    shutdownAbbrechen=1;

                    //Wenn man es sich doch anders Ueberlegt hat kamm man hier den Encodiervorgang abbrechen 
                    shutdownAbbrechen = QMessageBox::critical(eltern,ueberschrift,haupttext,
                                        QMessageBox::Cancel,QMessageBox::NoButton,QMessageBox::NoButton);

                    // Den Rueckgabe wert des Dialogs auswerten
                    if((shutdownAbbrechen==2)||(shutdownAbbrechen==0))
                    {
                        // herunterfahren verhindern
                        boolshutdown=false;
                    }
                }
            }

            // Der Decodiervorgang ist abgeschlossen sende das Signal feritg
            emit fertig();

            // Und setze die Variablen zurueck
            var_reset();
        }
    }
    else
    {
        // Meldungen vom Aufruf holen, wenn gerade encodiert wird
        meldungen();
    }
}

void Decodieren::anhalten(void)
{
    // im 2Pass gleich "boolanhalten" auf true setzen
    if(bool2pass==false)
    {
        cout<<"if1"<<endl;
        boolanhalten=true;
    }
    else
    {
        // wenn noch ein 2Durchlauf kommt dann setzte den voralarm
        boolvoranhalten=true;
    }
}

void Decodieren::abbrechen(void)
{
    // Kontrolle Welche Sprache eingestellt ist
    if(sprache=="de")
    {
        ueberschrift="Wirklich Abbrechen?";
        haupttext   ="Wenn sie jetzt Abbrechen wird der aktuelle Film,\nnicht vollstaendig sein! Trotzdem Abbrechen?";
    }

    if(sprache=="en")
    {
        ueberschrift="Realy Abort?";
        haupttext   ="The movie will not be complete if you abort now!\n      Abort nevertheless? ";
    }


    // Nocheinmal Rueckfragen ob der Aufruf wircklich abgebrochen werden soll
    if(1==QMessageBox::warning(eltern,ueberschrift,haupttext,QMessageBox::Ok,QMessageBox::Cancel))
    { 
        // Damit nach dem Abbrechen nicht weiter encodiert wird
        boolanhalten=true;

        // Den Thread abrechen der gerade am decodieren ist
        encodieraufruf->terminate();

        // Optische kleinichkeit
        cout<<endl<<endl;
    }
}

void Decodieren::meldungen (void)
{
    emit status(encodieraufruf->meldungen());
}
# endif
