/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Einstellungen.h"

# ifndef EINSTELLUNGEN_CPP
# define EINSTELLUNGEN_CPP

void Einstellungen::laden(QString pfad,QString versionsnummer)
{
    if(debuglevel==3)
    {
        cout<<" * Methode : laden *"<<endl<<endl;
    }

    if(debuglevel==2)
    {
        cout<<" Uebergebener Pfadname = "<<pfad<<endl<<endl;
    }

    // Der Pfad zum ".dvd2xvid" Ordner
    confpfad=pfad;

    // Versionnummer zuordnen
    version=versionsnummer;

    // Oeffnen der "config" Datei 
    ifstream einlesen((confpfad+"conf"));

    // Kontrolliert ob die Datei geoeffnet werden konnte
    if(!einlesen)
    {
        if(debuglevel==3)
        {
            cout<<" Konnte keine conf Datei oeffnen, Neue wurde erstellt."<<endl<<endl;
        }

        // erstellt einen versteckten Ordner 
        system(("mkdir "+confpfad));

        // setzt alle Werte auf Standard zurueck
        ruecksetzen();

        // Ordnungsgemaeses schliesen der Confdatei
        einlesen.close();

        // Speichert legt eine Ordentliche Confdatei an
        speichern();
    }
    else
    {
        if(debuglevel==3)
        {
            cout<<" Konnte die conf Datei oeffnen"<<endl<<endl;
        }

        // Erste Zeile wird Eingelsen mit Versionsnummer wird eingelesen wird momentan noch nicht gebraucht
        getline(einlesen,temp);

        if(debuglevel==3)
        {
            cout<<" Versionsnummer = "<<temp<<endl<<endl;
        }

        // Zeile mit "indirname" wird einglesen und zugewiesen
        getline(einlesen,temp);
        indirname=temp;

        if(debuglevel==3)
        {
            cout<<" Indirname = "<<temp<<endl<<endl;
        }

        // Zeile mit "outfilename" wird einglesen und zugewiesen
        getline(einlesen,temp);
        outfilename=temp;

        if(debuglevel==3)
        {
            cout<<" Outfilename = "<<temp<<endl<<endl;
        }

        // Zeile mit "audioopt" wird einglesen und zugewiesen
        getline(einlesen,temp);
        audioopt=temp;

        if(debuglevel==3)
        {
            cout<<" Audiooptionen = "<<temp<<endl<<endl;
        }

         // Zeile mit "bitrateopt" wird einglesen und zugewiesen
        getline(einlesen,temp);
        bitrateopt=temp;

        // Zeile mit "mountpfad wird einglesen und zugewiesen
        getline(einlesen,temp);
        mountpfad=temp;

        if(debuglevel==3)
        {
            cout<<" Bitrateoptionen = "<<temp<<endl<<endl;
        }

        // Zeile mit "debuglevel" wird einglesen und zugewiesen
        getline(einlesen,temp);
        debuglevel=atoi(temp.c_str());

        if(debuglevel==3)
        {
            cout<<" Debuglevel = "<<temp<<endl<<endl;
        }

        // Zeilen mit Bool Varibalen werden einglesen und zugewiesen
        einlesen>>boolcartoon;
        einlesen>>bool2pass;
        einlesen>>boolautoaspect;
        einlesen>>boolshutdown;
        einlesen>>boolunmount;
        einlesen>>booleject;
        einlesen>>boolzusammenfuegen;
        einlesen>>boolpart;

        // Zeile mit "debuglevel" wird einglesen und zugewiesen
        getline(einlesen,temp);
        getline(einlesen,temp);


        if(debuglevel==3)
        {
            cout<<" Sprache = "<<temp<<endl<<endl;
        }

        // Kontrolle ob das Ende erreicht ist, (vermeiden von Fehlern mit aeltern Versionen)
        if(temp=="")
        {
            // sprache auf Standart Wert setzen
            sprache="de";
        }
        else
        {
            // eingelesen wert sprache zuweisen
            sprache=temp;
        }

        // Zeile mit vhqWert einlesen
        getline(einlesen,temp);


        if(debuglevel==3)
        {
            cout<<" vhqWert = "<<temp<<endl<<endl;
        }

        // Kontrolle ob das Ende erreicht ist, (vermeiden von Fehlern mit aeltern Versionen)
        if(temp=="")
        {
            // sprache auf Standart Wert setzen
            vhqWert="0";
        }
        else
        {
            // eingelesen wert sprache zuweisen
            vhqWert=temp;
        }

        // eingelesen wert sprache zuweisen
        einlesen>>boolausgeben;

        // Ordnungsgemaeses schliesen der Confdatei
        einlesen.close();

    }
}

void Einstellungen::ruecksetzen(void)
{
    if(debuglevel==2)
    {
        cout<<" * Methode : ruecksetzen *"<<endl<<endl;
    }

    // Denn Varablien eine Standardwert zuweisen
    indirname          = "/";
    outfilename        = "/tmp/out.avi";
    audioopt           = "copy";
    bitrateopt         = "1000";
    vhqWert            = "0";
    mountpfad          = "/mnt/dvd/";
    sprache            = "en";
    debuglevel         = 0;
    boolcartoon        = false;
    bool2pass          = false;
    boolautoaspect     = false;
    boolshutdown       = false;
    boolunmount        = false;
    booleject          = false;
    boolzusammenfuegen = false;
    boolpart           = false;
    boolausgeben       = false;
}

void Einstellungen::speichern (void)
{
    if(debuglevel==2)
    {
        cout<<" * Methode : speichern *"<<endl<<endl;
    }

    if(debuglevel==3)
    {
        cout<<" Confdatei wird geschrieben !"<<endl<<endl;
        cout<<" Version         = "<<version<<endl;
        cout<<" Indirname       = "<<indirname<<endl;
        cout<<" Outfilename     = "<<outfilename<<endl;
        cout<<" Audiooptionen   = "<<audioopt<<endl;
        cout<<" Bitrateoptionen = "<<bitrateopt<<endl;
        cout<<" Mountpfad       = "<<mountpfad<<endl;
        cout<<" Debuglevel      = "<<debuglevel<<endl;
        cout<<" Cartoon         = "<<boolcartoon<<endl;
        cout<<" 2Pass           = "<<bool2pass<<endl;
        cout<<" Autoaspect      = "<<boolautoaspect<<endl;
        cout<<" Shutdown        = "<<boolshutdown<<endl;
        cout<<" Umount          = "<<boolunmount<<endl;
        cout<<" Eject           = "<<booleject<<endl;
        cout<<" Zusammenfuegen  = "<<boolzusammenfuegen<<endl;
        cout<<" .part           = "<<boolpart<<endl;
        cout<<" Sprache         = "<<sprache<<endl;
        cout<<" vhqWert         = "<<vhqWert<<endl;
        cout<<" boolausgeben    = "<<boolausgeben<<endl;
    }

    // Oeffnen zum schreiben in der "config" Datei 
    ofstream schreiben((confpfad+"conf"));

    // Schreiben der Versionsnummer von "DVD2XVID"
    schreiben<<version<<endl;

    // Schreiben der einzelnen Variablen in die Datei
    schreiben<<indirname<<endl;
    schreiben<<outfilename<<endl;
    schreiben<<audioopt<<endl;
    schreiben<<bitrateopt<<endl;
    schreiben<<mountpfad<<endl;
    schreiben<<debuglevel<<endl;
    schreiben<<boolcartoon<<endl;
    schreiben<<bool2pass<<endl;
    schreiben<<boolautoaspect<<endl;
    schreiben<<boolshutdown<<endl;
    schreiben<<boolunmount<<endl;
    schreiben<<booleject<<endl;
    schreiben<<boolzusammenfuegen<<endl;
    schreiben<<boolpart<<endl;
    schreiben<<sprache<<endl;
    schreiben<<vhqWert<<endl;
    schreiben<<boolausgeben<<endl;

    // Ordnungsgemaeses schliesen der Confdatei
    schreiben.close();
}
# endif
