/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef GUI_H
# define GUI_H

# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <string>
# include <iostream>

# include <qapplication.h>
# include <qlabel.h>
# include <qpushbutton.h>
# include <qcheckbox.h>
# include <qcombobox.h>
# include <qpixmap.h>
# include <qtooltip.h>
# include <qframe.h>
# include <qprocess.h>
# include <qstring.h>
# include <qmessagebox.h>
# include <qrect.h>
# include <qdesktopwidget.h>


# include "Decodieren.h"
# include "Menuebar.h"
# include "DVDReader.h"
# include "Zeitfelder.h"
# include "Stapelfenster.h"

class Gui : public QObject
{
    Q_OBJECT
    private:
        QPushButton *encodieren,
                    *outfile,
                    *indir,
                    *beenden,
                    *vorschau,
                    *anhaengen,
                    *mount;

        QComboBox  *cobitrate,
                   *cobaudio,
                   *cotitel,
                   *coalang,
                   *countertitel,
                   *cobvhq;

        QCheckBox  *cbcartoon,
                   *cb2pass,
                   *cbautoaspect;

        QLabel *labelindirname,
               *labeloutname,
               *labelcartoon,
               *label2pass,
               *labelautoaspect,
               *labelaudio,
               *labelbitrate,
               *labeltitle,
               *labelalang,
               *labeluntertitel,
               *labelstartzeit,
               *labelendezeit,
               *labelvhq;

        Decodieren *decodieren;

        Menuebar   *menubar;

        Stapelfenster *stapel;

        QWidget    *window;

        DVDReader *dvd;                          // Mit diesen Objekt werden die DVD-Daten gelesen

        QProcess *process_mounten;

        Zeitfelder *startfeld,
                   *endfeld;

        bool boolmount,                          // damit sich das Programm merkt was es bei mount DVD tun soll
             boolmounterror;                     // Kontrolle ob es einen Fehler gegeben hat bei mounten

        QString temp,                            // Temporaere Ablage von QString Objekten, fuer mounten
                mountpfad,                       // Beinhaltet den Mount-Point fuer die DVD
                version,                         // Beinhaltet die Versionsnummer von dvd2xvid
                sprache,                         // Welche Sprache eingestellt ist
                name;                            // Der name der in der Titelleiste angezeigt werden soll

        short poshor,                            // fuer die Horizontale Position des Fensters
              posver,                            // fuer die Vertikale   Position des Fensters
              breite;                            // fuer die Breite des Fensters

        int debuglevel;                          // Der Debuglevle entscheidet wie viel Debuginformationen angezeigt werden

    public:
        Gui(int startdebuglevel,string versionsnummer);  // Konstruktor


    public slots:
        // Setzt alle veraendert Varibalen zurueck
        void ruecksetzen(void);

        // Hollt die Varibalen aus Einstellengn ueber Decodierne und setzt sie bei denn einzelne Widgets
        void anzeigen (void);

        // mountet eine Eingelegte DVD
        void mounten (void);

        // Indirsetzen nach dem mounten
        void setindirname (void);

        // Wenn Von der Standartausgabe gelesen werden kann nach den mount Befehl dann ist das ein Fehler
        void lese_mount (void);

        // Stelt das Fenster rechts ins rechte obere Eck
        void positionieren (void);

        // Die Sprache auf Deutsch setzen
        void setDeutsch(void);

        // Die Sprache auf English setzen
        void setEnglish(void);

        // Setzen des Debugwertes
        void setDebug  (int neuerdebug);

        // Alle Aufgaben die erfuellt werden muessen wen ein Encodier Vorgang fertig ist
        void fertig (void);

        // Die Schriftart und Schriftgroesse aenderen
        void setFont (int groesse);

        // Eine eventuell eingelegte DVD sicher entbinden
        void umount (void);
};

# endif
