/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Menuebar.h"

# ifndef MENUEBAR_CPP
# define MENUEBAR_CPP

Menuebar::Menuebar (QWidget *parent,Decodieren *uebergabe,int startdebug) : QMenuBar(parent)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Debuglevel setzen
    debuglevel=startdebug;

    // Speichert das Decodieren Objekt in der entsprechende Variable ab
    decodieren=uebergabe;

    /*        Einstellungs-Menue        */

    // Erstellt das Sprachen Menue
    sprache = new QPopupMenu(this);

    //Das Sprachenmenu mit Inhalt fuellen
    sprache->insertItem("Deutsch",0);
    sprache->insertItem("English",1);

    // Erstellt das Einstellungs Menue
    einstellungen = new QPopupMenu(this);

    // Das Einstellungsmenu mit Inhalten fuellen
    einstellungen-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/reload.png"),"Standard" ,1);
    einstellungen-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/filesave.png"),"",2);
    einstellungen-> insertSeparator();
    einstellungen-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/configure.png"),"",3);
    einstellungen-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/sprachen.png"),"",sprache,4);
    einstellungen-> insertSeparator();
    einstellungen-> insertItem(QPixmap("/usr/share/dvd2xvid/icons/exit.png"),"",5);

    /*           Debug-Menue            */

    // Erstellt das Debug Menue
    debug = new QPopupMenu(this);

    // Das Debugmenue mit inhalt fuellen
    debug-> insertItem("Level = 0",0);
    debug-> insertSeparator();
    debug-> insertItem("Level = 1",1);
    debug-> insertItem("Level = 2",2);
    debug-> insertItem("Level = 3",3);

    // Damit der zur Zeit aktive ausgewaehlt wird
    debug->setItemChecked(0,true);

    // Erstellt das Shutdown Menue
    optionen = new QPopupMenu(this);

    //Das Shutdownmenu mit Inhalt fuellen
    optionen->insertItem("",0);
    optionen->insertItem("",1);
    optionen->insertSeparator();
    optionen->insertItem("",2);
    optionen->insertItem("",3);
    optionen->insertSeparator();
    optionen->insertItem("",4);


    // Die PopMeunes werden der Menuebar zugewiesen
    insertItem("",einstellungen,0);
    insertItem("Debuglevel",debug,1);
    insertItem("",optionen,2);

    // Gespeicherte Werte abholen
    optionen->setItemChecked(0,decodieren->getunmount());

    // Wenn unmounten auf true steht dann kontrollier auch eject
    if (optionen->isItemChecked(0))
    {
        // Wenn ja dann setzt das Item auf true
        optionen->setItemChecked(1,decodieren->geteject());
    }
    else
    {
        // Wenn nicht dann mach es nicht anwaehlbar
        optionen->setItemEnabled(1,false);
    }

    //Gespeicherte Werte abholen
    optionen->setItemChecked(2,decodieren->getzusammenfuegen());

    // Wenn unmounten auf true steht dann kontrollier auch eject
    if (optionen->isItemChecked(2))
    {
        // Wenn ja dann setzt das Item auf true
        optionen->setItemChecked(3,decodieren->getpart());
    }
    else
    {
        // Wenn nicht dann mach es nicht anwaehlbar
        optionen->setItemEnabled(3,false);
    }

    //Gespeicherte Werte abholen
    optionen->setItemChecked(4,decodieren->getausgeben());

    // Die Schriftgoesse Standard maessig auf 10 stellen
    slot_setFont(10);

    slot_setdebug(debuglevel);

    /*              Events              */
    connect(einstellungen       ,SIGNAL(activated(int))    ,this    ,SLOT(slot_einstellungen(int)));
    connect(sprache             ,SIGNAL(activated(int))    ,this    ,SLOT(slot_sprachen(int)));
    connect(debug               ,SIGNAL(activated(int))    ,this    ,SLOT(slot_setdebug(int)));
    connect(optionen            ,SIGNAL(activated(int))    ,this    ,SLOT(slot_optionen(int)));
}

void Menuebar::slot_einstellungen(int  auswahl)
{
    // Sendet das Signale wenn ein Eintrag ausgewaehlt wird
    if (auswahl==1)
    {
        emit standard();
    }

    if (auswahl==2)
    {
        emit speichern();
    }

    if(auswahl==3)
    {
        bool ok;
        if(sprache->isItemChecked(0)==true)
        {
        // Einen Dialog mit der Eingabe moeglichkeit fuer denn Mountpfad der DVD in Deutsch
        temp=QInputDialog::getText(
                "Mountpfad", "Neuen Mountpfad eingeben:", QLineEdit::Normal,decodieren->getmountpfad(), &ok, eltern);
        }
        if(sprache->isItemChecked(1)==true)
        {
            // Einen Dialog mit der Eingabe moeglichkeit fuer denn Mountpfad der DVD in English
            temp=QInputDialog::getText(
                    "Mountpath", "Enter new mountpath:", QLineEdit::Normal,decodieren->getmountpfad(), &ok, eltern);
        }
        if(ok==true)
        {
            decodieren->setmountpfad(temp);
        }
    }

    // auwahl 4 = Sprachen siehe slot_sprachen 

    if(auswahl==5)
    {
        emit exit();
    }

}

void Menuebar::slot_setdebug(int auswahl)
{
    //Sendet das Signal mit dem Debugwert
    emit debugwert(auswahl);

    //Den Wert an setdebug senden
    decodieren->setdebug(auswahl);

    // damit man sieht welcher Debuglevel ausgewaehlt ist
    debug->setItemChecked(auswahl,true);

    // Damit alle anderne geloescht werden bzw auf notcheked gesetz werden
    for(int var1=0;var1<4;var1++)
    {
        // Kontrolle ob var1 Auswahl ist denn dieser Menuepunkt darf nicht zuruekgesetzt werden
        if (!(var1==auswahl))
        {
            debug->setItemChecked(var1,false);
        }
    }
}

void Menuebar::slot_optionen(int auswahl)
{
    // damit man sieht welche Punkte aktive sind
    if(optionen->isItemChecked(auswahl))
    {
        optionen->setItemChecked(auswahl,false);
    }
    else
    {
        optionen->setItemChecked(auswahl,true);
    }

    // Wenn unmounten aktiviert wird erst dann soll man auch oeffnen aktivieren koennen
    if(auswahl==0)
    {
        // Kontrolle ob dieses Item schon sichtbar ist
        if (optionen->isItemChecked(0))
        {
            // wenn nein dann mach es sichtbar
            optionen->setItemEnabled(1,true);
        }
        else
        {
            //  wenn ja dann mach es wieder unsichtbar 
            optionen->setItemEnabled(1,false);
            optionen->setItemChecked(1,false);
            decodieren->setbooleject(false);
        }
    }

    // Wenn unmounten aktiviert wird erst dann soll man auch oeffnen aktivieren koennen
    if(auswahl==2)
    {
        // Kontrolle ob dieses Item schon sichtbar ist
        if (optionen->isItemChecked(2))
        {
            // wenn nein dann mach es sichtbar
            optionen->setItemEnabled(3,true);
        }
        else
        {
            //  wenn ja dann mach es wieder unsichtbar 
            optionen->setItemEnabled(3,false);
            optionen->setItemChecked(3,false);
            decodieren->setpart(false);
        }
    }

    // Senden der ausgewaehlten Werte
    if(auswahl==0)
    {
        decodieren->setboolunmount(optionen->isItemChecked(auswahl));
    }

    if(auswahl==1)
    {
        decodieren->setbooleject(optionen->isItemChecked(auswahl));
    }

    if(auswahl==2)
    {
        decodieren->setzusammenfuegen(optionen->isItemChecked(auswahl));
    }

    if(auswahl==3)
    {
        decodieren->setpart(optionen->isItemChecked(auswahl));
    }

    if(auswahl==4)
    {
        decodieren->setausgeben(optionen->isItemChecked(auswahl));
    }
}

void Menuebar::ruecksetzen (void)
{
    // Rueksetzen aller Einstellungen
    optionen->setItemChecked(0,false);
    optionen->setItemChecked(1,false);
    optionen->setItemEnabled(1,false);
    optionen->setItemChecked(2,false);
    optionen->setItemChecked(3,false);
    optionen->setItemEnabled(3,false);
    optionen->setItemChecked(4,false);
    slot_setdebug(0);
}

void Menuebar::slot_sprachen(int auswahl)
{
    if(auswahl==0)
    {
        emit deutsch();
    }

    if(auswahl==1)
    {
        emit english();
    }
}

void Menuebar::setDeutsch(void)
{
    // Einstellung sichtbar machen
    sprache->setItemChecked(0,true);
    sprache->setItemChecked(1,false);

    // Alles was moeglich ist aendern auf Deutsch
    changeItem (0,"Datei");
    changeItem (2,"Optionen");

    einstellungen->changeItem (2,"Speichern");
    einstellungen->changeItem (3,"Mountpfad");
    einstellungen->changeItem (4,"Sprache");
    einstellungen->changeItem (5,"Beenden");

    optionen->changeItem(0,"DVD danach loesen");
    optionen->changeItem(1,"DVD danach auswerfen");
    optionen->changeItem(2,"Dateien zusammenfuegen");
    optionen->changeItem(3,".part Dateien loeschen");
    optionen->changeItem(4,"Encodiermeldungen");
}

void Menuebar::setEnglish(void)
{
    // Einstellung sichtbar machen
    sprache->setItemChecked(0,false);
    sprache->setItemChecked(1,true);

    // Alles was moeglich ist aendern auf English
    changeItem (0,"File");
    changeItem (2,"Option");

    einstellungen->changeItem (2,"Save");
    einstellungen->changeItem (3,"Mountpath");
    einstellungen->changeItem (4,"Language");
    einstellungen->changeItem (5,"Quit");

    optionen->changeItem(0,"When finished umount");
    optionen->changeItem(1,"When finished eject");
    optionen->changeItem(2,"Bond files ");
    optionen->changeItem(3,"Delete .part files");
    optionen->changeItem(4,"Encoding Messages");
}


void Menuebar::slot_setFont(int schrift)
{
    // Aendern der Schriftgroesse in der Gesamten menuebar
    setFont(QFont("SansSerif",schrift));

    debug         ->setFont(QFont("SansSerif",schrift));
    sprache       ->setFont(QFont("SansSerif",schrift));
    optionen      ->setFont(QFont("SansSerif",schrift));
    einstellungen ->setFont(QFont("SansSerif",schrift));
}
# endif
