/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef MENUEBAR_H
# define MENUEBAR_H

# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <qmenubar.h>
# include <qpopupmenu.h>
# include <qpixmap.h>
# include <qinputdialog.h>
# include <qstring.h>

# include "Decodieren.h"


class Menuebar : public QMenuBar
{
    Q_OBJECT
    private:
        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QPopupMenu *einstellungen,               // Erstellt das Datei    Menue
                   *debug,                       // Erstellt das Debug    Menue
                   *optionen,                    // Erstellt das Shutdown Menue
                   *sprache;                     // Erstellt das Sprachen Menue

        Decodieren *decodieren;

        QString temp;                            // Temporaeren Stringobjekt fuer Mountpfad



        int debuglevel;

    public:
        Menuebar(QWidget *parent,Decodieren *uebergabe,int startdebug);

    private slots:
        void slot_einstellungen(int auswahl);
        void slot_sprachen     (int auswahl);
        void slot_setdebug     (int auswahl);
        void slot_optionen     (int auswahl);
        void slot_setFont      (int schrift);

    public slots:

        // Rueksetzen aller Einstellungen
        void ruecksetzen (void);

        // Die Sprache in der Menuebar auf Deutsch setzen
        void setDeutsch  (void);

        // Die Sprache in der Menuebar auf English setzen
        void setEnglish  (void);

    signals:
        void speichern  (void);
        void standard   (void);
        void exit       (void);
        void deutsch    (void);
        void english    (void);
        void debugwert  (int);
};

# endif
