/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Stapelfenster.h"

# ifndef STAPELFENSTER_CPP
# define STAPELFENSTER_CPP

Stapelfenster::Stapelfenster(QWidget *parent,int poshor,int posver,Decodieren *uebergabeDecodieren)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Speichert das decodieren Object ab
    decodieren=uebergabeDecodieren;

    // boolpart auf Abgespeicherten wert setzen
    boolpart=decodieren->getzusammenfuegen();

    // Setzt die Groesse un Poition des Fensters
    setGeometry(poshor,posver,485,40);

    // Den Anfangswert fuer die Zeilenvariable festlegen
    zeile=1;

    // "prozent" Variablen zuruecksetzen
    prozent=" 0";
    prozentspeicher=" 0";

    // Abgrenzungslinie bei der Ueberschrift
    QFrame *hlinie1 = new QFrame(this);
    hlinie1->setPaletteForegroundColor(Qt::lightGray);
    hlinie1->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie1->setLineWidth(1);
    hlinie1->setGeometry(2,19,481,1);

    // Ueberschrift erstellen
    ueber1 = new QLabel(this);
    ueber1->setGeometry(0,1,17,18);
    ueber1->setFont(QFont("SansSerif",10));

    ueber2 = new QLabel(this);
    ueber2->setGeometry(80,1,150,18);
    ueber2->setFont(QFont("SansSerif",10));

    ueber3 = new QLabel(this);
    ueber3->setGeometry(355,1,130,18);
    ueber3->setFont(QFont("SansSerif",10));

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    starten = new QPushButton("Start",this);
    starten->setFont(QFont("SansSerif",10));

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    loeschen = new QPushButton("Reset",this);
    loeschen->setFont(QFont("SansSerif",10));

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    anhalten = new QPushButton("Stop",this);
    anhalten->setFont(QFont("SansSerif",10));
    anhalten->hide();

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    abbrechen = new QPushButton("Abbrechen",this);
    abbrechen->setFont(QFont("SansSerif",10));
    abbrechen->hide();

    // Ob der Computer nach dem Decodieren heruntergefahren werden soll
    cbshutdown = new QCheckBox(this);
    cbshutdown->setChecked(decodieren->getshutdown());

    // Beschriftung fuer "cbshutdown" (CartoonOptimierung aktivieren)
    labelshutdown = new QLabel(this);
    labelshutdown->setFont(QFont("SansSerif",10));

    //Die Zeilen einmal erstellen
    for(int var=0;var<10;var++)
    {
        stapelzeile[var] = new Stapelzeile(this);
    }

    // Die Statuszeile einmal erstellen
    statuszeile = new Statuszeile(this);
    /************************************/
    /*              Events              */
    /************************************/

    // Beim Drueckn vom Start Knopf sollte der Vorgang gesartete werden
    QObject::connect(starten,       SIGNAL(released()),                  decodieren,      SLOT(starten()));

    // Alle Auftraege sollen geloescht werden
    QObject::connect(loeschen,      SIGNAL(released()),                  decodieren,      SLOT(var_reset()));
    QObject::connect(loeschen,      SIGNAL(released()),                  this,            SLOT(reset()));

    // beim Druekcen von Anhalten soll beim naechste Encodiervorgang unterbrochen werden
    QObject::connect(anhalten,      SIGNAL(released()),                  decodieren,     SLOT(anhalten()));
    QObject::connect(anhalten,      SIGNAL(released()),                  this,           SLOT(anhalten_deaktivieren()));

    // beimDruecken von Abbrechen soll der Encodiervorgang sofort abgebrochen werden, ohne verzoegerung
    QObject::connect(abbrechen,     SIGNAL(released()),                  decodieren,     SLOT(abbrechen()));

    // Wenn die Checkbox aktiviert wird wird das Siganl an "setshutdown" weietrgegeben
    QObject::connect(cbshutdown,    SIGNAL(toggled(bool)),               decodieren,     SLOT(setshutdown(bool)));

    // Die Statuswerte werden weitergegeben und an Statuszeile geschickt
    QObject::connect(decodieren,    SIGNAL(status(QString)),               this,     SLOT(setStatus(QString)));

    // Die Statuswerte werden weitergegeben und an Statuszeile geschickt
    QObject::connect(decodieren,    SIGNAL(part(bool)),                    this,     SLOT(setPartName(bool)));

}

void Stapelfenster::addZeile(QString inhalt,QString titel,bool cartoon,bool pass2,bool autoaspect)
{
    // Die Groesse des Fensters anpassen 
    groesse();

    // Vom Ausgabenamen den Pfadteil trennen
    inhalt.remove(0,(inhalt.findRev("/",-1,false)+1));

    // Wenn "boolpart" auf true ist dann soll beim Titel die ".part" Endung hinzugefuegt werden
    if(boolpart==true)
    {
        inhalt+=".part";
    }

    stapelzeile[zeile]->makeZeile(inhalt,titel,0,20*zeile,zeile,cartoon,pass2,autoaspect);

    // Damit der naechste Aufruf auch in der naechsten Zeile Statt findet
    zeile++;

    // Wenn Fenster unsichtbar dann mach es sichtbar
    if(isShown()==false)
    {
        // Das Fenster wieder sichtbar machen
        show();
    }

    repaint();

    // Die Position des Fensters beim ersten Aufruf anpassen
    if(zeile==2)
    {
        position();
    }

    emit hinzugefuegt();
}

void Stapelfenster::reset(void)
{
    hide();

    // Die Knoepfe wider einschalten
    anhalten ->setEnabled(true);
    anhalten ->hide();
    abbrechen->hide();
    loeschen ->show();
    starten  ->show();

    // Die Statuszeile auch wieder ausblenden
    statuszeile->hideZeile();

    //Die Zeilen Ausblenden
    for(int var=0;var<10;var++)
    {
        stapelzeile[var]->hideZeile();
    }

    // Zeilenvariable zuruecksetzen
    zeile=1;

    // "prozent" Variablen zuruecksetzen
    prozent=" 0";
    prozentspeicher=" 0";
}

void Stapelfenster::groesse (void)
{
    hoehe=20+(zeile*20);

    // Festlegen der Minimum und Maximumgroesse des Fensters
    setMinimumSize(485,hoehe+34);
    setMaximumSize(485,hoehe+34);

    // Die Poition des Knopfes anpassen
    starten      ->setGeometry(385,hoehe+4,85 ,25);
    loeschen     ->setGeometry(25, hoehe+4,85 ,25);
    anhalten     ->setGeometry(25, hoehe+4,85 ,25);
    abbrechen    ->setGeometry(385,hoehe+4,85 ,25);
    cbshutdown   ->setGeometry(135,hoehe+7,20 ,20);
    labelshutdown->setGeometry(155,hoehe+4,200,25);
}

void Stapelfenster::position (void)
{
    QRect hauptfenster;
    hauptfenster=eltern->frameGeometry();
    move(QPoint(hauptfenster.left(),(hauptfenster.top()+420)));
}

void Stapelfenster::setDeutsch (void)
{
    // Fenster Titel auf Deutsch setzen
    setCaption("Stapelverarbeitung - dvd2xvid");

    // Ueberschriftn auf Detusch setzen
    ueber1       ->setText("Nr");
    ueber2       ->setText("Ausgabename");
    ueber3       ->setText("Titel Ze  2P  Au");
    labelshutdown->setText("Am Ende herunterfahren");
    abbrechen    ->setText("Abbrechen");

    // ToolTips erklaeren die Funktion von den Knopf
    QToolTip::setWakeUpDelay(2000);
    QToolTip::setFont(QFont("SansSerif",10));
    QToolTip::add( cbshutdown,"Der Computer wird nach dem Encodieren heruntergefahren." );
    QToolTip::add( starten,   "Beginnt mit der Encodierung." );
    QToolTip::add( loeschen,  "Alle Auftraege die bis jetzt eingefeugt wurden, werden geloescht." );
    QToolTip::add( anhalten,  "Nachdem dieser Film fertig ist, wird die Stapleverarbeitung unterbroche.");
    QToolTip::add( abbrechen, "Der Encodiervorgang wird sofort unterbrochen.");
}

void Stapelfenster::setEnglish (void)
{
    // Fenster Titel auf Deutsch setzen
    setCaption("Batch processing - dvd2xvid");

    // Ueberschriftn auf Detusch setzen
    ueber1       ->setText("Nr");
    ueber2       ->setText("Outfile");
    ueber3       ->setText("title ze  2p  au");
    labelshutdown->setText("Shutdown at end");
    abbrechen    ->setText("Abort");

    // ToolTips erklaeren die Funktion von den Knopf
    QToolTip::setWakeUpDelay(2000);
    QToolTip::setFont(QFont("SansSerif",10));
    QToolTip::add( cbshutdown,"Shuts down the computer after encoding." );
    QToolTip::add( starten,   "Start the encoding." );
    QToolTip::add( loeschen,  "Remove all job's in the batch processinglist.");
    QToolTip::add( anhalten,  "Stop's all job's after this movie.");
    QToolTip::add( abbrechen, "Abort now encoding.");
}

void Stapelfenster::setUeberschrift (int aktiveZeile,bool pass2,bool letzter)
{
    // Wenn dies der letzte Aufruf ist ist der Knopg "anhalten" nicht mehr noetig
    if(letzter==true)
    {
        anhalten->setEnabled(false);
    }

    // Als erters die Prozent des Encodiervorgangs beim Starten anzeigenanzeigen
    temp=" 0% ";

    // Und wenn es der 2 Pass ist dann fuege Pass-2 hinzu
    if(pass2==true)
    {
        temp+="P-2 ";
    }
    else
    {
        temp+="P-1 ";
    }
    statuszeile->setpass(pass2);

    // Zuerst einmal den Text aus der Zeile holen
    temp+=stapelzeile[aktiveZeile+1]->namen();

    if(0<aktiveZeile)
    {
        // Diese Zeile als aktiv Kennzeichnen
        stapelzeile[aktiveZeile]->deaktivire();
    }

    // Diese Zeile als aktiv Kennzeichnen
    stapelzeile[aktiveZeile+1]->aktivire();

    // Die Knoepfe ausschalten
    loeschen ->hide();
    starten  ->hide();
    anhalten ->show();
    abbrechen->show();

    // Setzt den Namen im Fenster
    setCaption(temp);

    // Die Statuszeile noch hinzufuegen
    addStatus();
}

void Stapelfenster::setUeberschrift(void)
{
    // Die aktuelle Ueberschrift heraus holen
    temp=caption();

    // Die ersten drei Zeichen der Ueberschrift wegschneiden
    temp.remove(0,(temp.find("%",0,false))+1);

    // Die aktuell prozentzahl hinzufuegen
    temp.insert(0,prozent+"%");

    // Die Uebrschrift wieder anzeigen
    setCaption(temp);

}

void Stapelfenster::anhalten_deaktivieren(void)
{
    // Damit wird der Knopf anhlten deaktiviert damit erkannt wird das die engabe erkannt worden ist
    anhalten->setEnabled(false);
}

void Stapelfenster::addStatus (void)
{
    // Einmal die Groesse vom Fenster anpassen
    groesse();

    // Die Zeile hinzufuegen
    statuszeile->makeZeile(0,20*zeile,zeile);
}

void Stapelfenster::setStatus(QString status)
{
    //Statuswert weiterreichen
    statuszeile->statuswerte(status);

    // Wert von den Prozenten in der Variable "prozent" abspeichern
    prozent=status.mid(22,2);

    // kontrolle ob siet der dem letzten mal eine veraenderung statgefunden hat
    if(!(prozent==prozentspeicher))
    {
        prozentspeicher=prozent;
        setUeberschrift();
    }
}

void Stapelfenster::setPartName(bool part)
{
    boolpart=part;

    // Zuerts einmal Kontrolle ob es schon zeilen gibt
    if(1<zeile)
    {
        // Dann Kontrolle ob part hinzugefuegt oder entfern werden soll
        if(boolpart==true)
        {
            // Bei allen schon vorhanden Zeilen ".part" hinzufuegen
            for(int var=1;var<zeile;var++)
            {
                stapelzeile[var]->setName(stapelzeile[var]->namen()+".part");
            }
        }
        else
        {
            // Bei "false" die .part Endungen wieder entfernen
            for(int var=1;var<zeile;var++)
            {
                //Einmal den Text aus der Zeile holen
                temp=stapelzeile[var]->namen();
                stapelzeile[var]->setName(temp.left(temp.length()-5));
            }
        }
    }
}

void Stapelfenster::closeEvent(QCloseEvent* schliessen)
{
    //Kontrolle ob schon decoiert wird oder nicht
    if(starten->isShown()==true)
    {
        //Wenn ja, mach ein Reste
        reset();

        // Und alle Varibalen in Decodiern zuruecksetzen
        decodieren->var_reset();
    }
    else
    {
        // Wenn nein dann breche das decodieren ab
        decodieren->abbrechen();
    }
}
#endif
