/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef STAPELFENSTER_H
# define STAPELFENSTER_H

# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <qwidget.h>
# include <qstring.h>
# include <qlabel.h>
# include <qtooltip.h>
# include <qrect.h>
# include <qpushbutton.h>

# include "Stapelzeile.h"
# include "Statuszeile.h"
# include "Decodieren.h"


class Stapelfenster : public QWidget
{
    Q_OBJECT
    private:
        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QLabel *ueber1,                          // 1 Ueberschrift = "Nr"
               *ueber2,                          // 2 Ueberschrift = "Ausgabename"
               *ueber3,                          // 3 Ueberschrift = "Titel Ze  2P  Au"
               *labelshutdown;                   // Die Beschriftung fuer das Shutdownfeld

        QPushButton *starten,                    // Mit diesen Knopf soll der Encodiervorgang gestartet werden
                    *loeschen,                   // Mit diesen Knopf wird der Staple geloescht
                    *anhalten,                   // Mit diesen Knopf wird der naechste Aufruf unterbrochen
                    *abbrechen;                  // Mit deisen Knopf kann der Encodiervorgang abgebrochen werden

        QCheckBox *cbshutdown;                   // Damit wird festgelegt ob der Pc nachher herunter gefahren werden soll

        Stapelzeile *stapelzeile[10];            // Die 10 Einzelenen Zeilen mit den Auftraegen

        Statuszeile *statuszeile;                // Die Zeile mit den Statusinfos waehrend des Encodierens

        Decodieren *decodieren;                  // Ein Decodieren Object fuer Datenaustausch

        QString  temp,                           // Ein QString zum zusammenbauen des Fenstertitels waehrend des Encodieren
                 prozent,                        // Der Prozent der encodiert Status
                 prozentspeicher;                // Der Prozentwert seit dem letzten mal

        int zeile,                               // Beinhaltet die aktuelle Zeile
            hoehe;                               // Die hoehe des Fensters

        bool boolpart;                           // Ob am Dateinamen part angehaengt werden soll
    public:
        Stapelfenster(QWidget *parent,int poshor,int posver,Decodieren *uebergabeDecodieren);

    signals:
        // Wird gesendet wenn das hinzufuegen der Zeile beendet ist
        void hinzugefuegt(void);

    public slots:
        // Soll einen Neue Zeile im Fenster hinzufuegen
        void addZeile(QString inhalt,QString titel,bool cartoon,bool pass2,bool autoaspect);

        // Alles zuruecksetzen
        void reset (void);

        // Die Groesse des Fensters anpassen
        void groesse (void);

        // Die Poition des Fensters am Hauptfenster ausrichten
        void position (void);

        // Sprache in Staplefenster auf Deutsch stellen
        void setDeutsch (void);

        // Sprache in Staplefenster auf English stellen
        void setEnglish (void);

        // Die Ueberschrift im Stapelfenster festlegen (Beim Start des Encodiervorgangs)
        void setUeberschrift (int aktiveZeile,bool pass2,bool letzter);

        // Die Ueberschrift im Stapelfenster aendern wenn sich die Prozent werte geaendert haben
        void setUeberschrift (void);

        // Damit wird der Knopf "anhalten" deaktiviert damit erkannt wird das die engabe erkannt worden ist
        void anhalten_deaktivieren(void);

        // Statuszeile hinzufuegen
        void addStatus (void);

        // Statuswerte setzen
        void setStatus (QString status);

        // Die Namen in den bereits existierden Zeilen richtig stellen
        void setPartName(bool part);

    protected:
        void closeEvent(QCloseEvent* schliessen);
};

# endif
