/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Statuszeile.h"

# ifndef STATUSZEILE_CPP
# define STATUSZEILE_CPP

Statuszeile::Statuszeile(QWidget *parent)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Die Heoeh der einzelnen Widgets festlegen
    hoehe=20;

    // Welche Sekunde gerade encodiert wird
    sekunden= new QLabel(eltern);
    sekunden->setFont(QFont("SansSerif",10));

    // Wie lnge es noch ca. dauert
    dauer = new QLabel(eltern);
    dauer->setFont(QFont("SansSerif",10));

    // Wei Gross die Datei in etwar wird
    groesse = new QLabel(eltern);
    groesse->setFont(QFont("SansSerif",10));

    // Ob 1 oder 2 Durchgang (pass)
    pass = new QLabel(eltern);
    pass->setFont(QFont("SansSerif",10));

    // Fueftgt eine zwischen Linie ein
    vlinie1 = new QFrame(eltern);
    vlinie1->setPaletteForegroundColor(Qt::lightGray);
    vlinie1->setFrameStyle(QFrame::VLine|QFrame::Plain);
    vlinie1->setLineWidth(1);
    //vlinie1->setPaletteForegroundColor(Qt::black);

    // Fueftgt eine zwischen Linie ein
    vlinie2 = new QFrame(eltern);
    vlinie2->setPaletteForegroundColor(Qt::lightGray);
    vlinie2->setFrameStyle(QFrame::VLine|QFrame::Plain);
    vlinie2->setLineWidth(1);
    //vlinie2->setPaletteForegroundColor(Qt::black);

    // Fueftgt eine zwischen Linie ein
    vlinie3 = new QFrame(eltern);
    vlinie3->setPaletteForegroundColor(Qt::lightGray);
    vlinie3->setFrameStyle(QFrame::VLine|QFrame::Plain);
    vlinie3->setLineWidth(1);
    //vlinie3->setPaletteForegroundColor(Qt::black);

    // Fueftgt eine zwischen Linie ein
    hlinie1 = new QFrame(eltern);
    hlinie1->setPaletteForegroundColor(Qt::lightGray);
    hlinie1->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie1->setLineWidth(2);
    //hlinie1->setPaletteForegroundColor(Qt::black);

    // Fueftgt eine zwischen Linie ein
    hlinie2 = new QFrame(eltern);
    hlinie2->setPaletteForegroundColor(Qt::lightGray);
    hlinie2->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie2->setLineWidth(1);
    //hlinie2->setPaletteForegroundColor(Qt::black);

    hideZeile();
}

void Statuszeile::makeZeile(int poshor,int posver, int zeile)
{
    // Macht alle Widgets einmal sichtbar
    showZeile();

    // Welcher durchgang gerade abgearbeitet wird
    pass->setGeometry(poshor+5,posver,45,hoehe);

    // Wie Gross die Datei ca werden wird
    groesse->setGeometry(poshor+58,posver,120,hoehe);

    // Wie lange der encodiervorgeng noch ca brauchen wird
    dauer->setGeometry(poshor+187,posver,115,hoehe);

    //  Wie viel Prozent und wieviel Sekunden schon encodiert worden sind
    sekunden->setGeometry(poshor+310,posver,188,hoehe);

    // Abgrenzungslinie zwischen pass und groesse
    vlinie1->setGeometry(poshor+52,posver+1,5,18);

    // Abgrenzungslinie zwischen groesse und restzeit
    vlinie2->setGeometry(poshor+180,posver+1,5,18);

    // Abgrenzungslinie zwischen restzeit und Encodiersatus
    vlinie3->setGeometry(poshor+305,posver+1,5,18);

    // Abgrenzungslinie unter der Zeile
    hlinie1->setGeometry(2,(20*zeile)+19,481,2);

    // Abgrenzungslinie unter der Zeile
    hlinie2->setGeometry(2,(20*zeile),481,1);
}

void Statuszeile::hideZeile (void)
{
    // Alles Ausblenden
    sekunden->hide();
    dauer->hide();
    groesse->hide();
    pass->hide();
    vlinie1->hide();
    vlinie2->hide();
    vlinie3->hide();
    hlinie1->hide();
    hlinie2->hide();

    // Die Status texte loeschen
    groesse ->setText("");
    dauer   ->setText("");
    sekunden->setText("");
}

void Statuszeile::showZeile(void)
{
    // Alles Einblenden
    sekunden->show();
    dauer->show();
    pass->show();
    groesse->show();
    vlinie1->show();
    vlinie2->show();
    vlinie3->show();
    hlinie1->show();
    hlinie2->show();
}

void Statuszeile::statuswerte (QString status)
{
    //Werte herrausfiltern
    groesse->setText("Groesse : "+(status.mid(48,6)));
    dauer  ->setText("Restzeit : "+(status.mid(41,7)));
    sekunden->setText("Encodiert : "+(status.mid(5,4))+" sek / "+(status.mid(22,2)+" %"));
}

void Statuszeile::setpass (bool pass2)
{
    if(pass2==false)
    {
        pass->setText("Pass 1");
    }
    else
    {
        pass->setText("Pass 2");
    }
}
# endif
