/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef ZEITFELDER_H
# define ZEITFELDER_H


# ifndef __STDC_LIMIT_MACROS
# define __STDC_LIMIT_MACROS
# endif

# include <qlineedit.h>
# include <qvalidator.h>
# include <qlabel.h>
# include <qstring.h>
# include <qtooltip.h>

# include <iostream>

using namespace std;


class Zeitfelder : public QObject
{
    Q_OBJECT

    private:
        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QLineEdit *stunden,                     // Stundenfeld
                  *minuten,                     // Minutenfeld
                  *sekunden,                    // Sekundenfeld
                  *korrektur;                   // Korrekturfeld in Sekunden

        int posver,                             // Vertikale Position des Feldes
            poshor,                             // Horizontale Position des Feldes
            debuglevel;

        bool boolkontrolle;                     // Damit wir Kontrolliert ob alle drei Felder richtig sind

        QString pruefen,                        // Darin werden die 3 Felder Ueberpruft ob ihr Syntax stimmt
                dreifelder,                     // Alle drei Felder in einem QString
                leerkontrolle;                  // Temporaere Ablage fuer die Leerkontrolle


    public:
        Zeitfelder(QWidget *parent, int vertical, int horizontal,int startdebug,bool korrekturfeld);            // Konstruktor

    signals:

        // Sendet den Inhalt der 3Felder als QString wenn er sich aendert
        void zeitgeaendert(const QString&);

        // korrekturwert geaendert
        void korrekturgeandert (const QString&);

    public slots:

        //Verarbeitet die drei Felder zusammen und sendet das Siganl "zeitgeaendert"
        void zusammenfuegen(const QString& uebergabe);

        // Alle Werte Ruecksetzen
        void ruecksetzen(void);

        // nur das Korrektur feld zuruecksetzen
        void korrektur_zuruecksetzen(void);

        // Kontrolliert die Werte der Zeichenkette
        void kontrolle (void);

        // Den Debuglevel neu setzen
        void setDebug (int newDebug);

        // Wird aufgerufen wenn sich der Wert in Korrektur geandert hat
        void slotKorrektur (const QString& uebergabe);

        // Die Sprache auf Deutsch setzen
        void setDeutsch(void);

        // Die Sprache auf English setzen
        void setEnglish(void);
};

# endif
